﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using Tao.OpenGl;

namespace SPS2
{
    public class Display
    {
        public Presentation presentation;
        public Scene scene;
        private int m_pageno;
        public int pageno
        {
            get { return m_pageno; }
            set
            {
                scene.page = presentation.Pages[value];
                scene.pauselevel = 0;
                m_pageno = value;
            }
        }

        /// <summary>
        /// 0 = 通常, 1 = flip
        /// </summary>
        [Obsolete]
        public int state
        {
            get { return m_state; }
            set {
                m_state = value; 
            }
        }
        public int m_state;

        public Flip.Parameter flip_param;
        public void Flip()
        {

#if false
            Gl.glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
            float alpha = (float)flip_param.elapsed_ms / 500.0f;

            if (flip_param.elapsed_ms < 500)
            {
                // fade out
                flip_param.scene_before.Draw(this);

            }
            else
            {
                // fade in
                flip_param.scene_after.Draw(this);
                alpha = 2.0f - (float)flip_param.elapsed_ms / 500.0f;
            }

            Gl.glColor4f(0.0f, 0.0f, 0.0f, alpha);

            Gl.glDisable(Gl.GL_TEXTURE_2D);
            Gl.glLoadIdentity();
            Gl.glBegin(Gl.GL_QUADS);
            Gl.glVertex2f(-Width / 2.0f, -Height / 2.0f);
            Gl.glVertex2f(Width / 2.0f, -Height / 2.0f);
            Gl.glVertex2f(Width / 2.0f, Height / 2.0f);
            Gl.glVertex2f(-Width / 2.0f,Height / 2.0f);
            Gl.glEnd();
            
            Gl.glEnable(Gl.GL_TEXTURE_2D);
            if (flip_param.elapsed_ms >= 1000)
            {
                state = 0;
            }
#else

            float alpha;
            float ratio_base = 50.0f;
           
            // fade out
//            alpha = (flip_param.elapsed_ms > 400 ? 1.7f - flip_param.elapsed_ms / 500.0f : 1.0f);
            alpha = 1.0f - flip_param.elapsed_ms / 1000.0f;
            Gl.glColor4f(1.0f, 1.0f, 1.0f, alpha);

            foreach (DrawUnit u in flip_param.scene_before.page.drawunits)
            {
                if (u.pauselevel > flip_param.scene_before.pauselevel) continue;
                Gl.glLoadIdentity();
                Gl.glTranslatef(u.X - Width / 2.0f + u.sprite.Width / 2.0f, u.Y - Height / 2.0f + u.sprite.Height / 2.0f, 0.0f);
                float ratio = flip_param.elapsed_ms / ratio_base + 1.0f;
                Gl.glScalef(ratio, ratio, 1.0f);
                u.sprite.Draw();
            }

            if (flip_param.elapsed_ms > 500)
            {
                alpha = flip_param.elapsed_ms / 500.0f - 1.0f;
                Gl.glColor4f(1.0f, 1.0f, 1.0f, alpha);

                // fade in
                foreach (DrawUnit u in flip_param.scene_after.page.drawunits)
                {
                    if (u.pauselevel > flip_param.scene_after.pauselevel) continue;
                    Gl.glLoadIdentity();
                    Gl.glTranslatef(u.X - Width / 2.0f + u.sprite.Width / 2.0f, u.Y - Height / 2.0f + u.sprite.Height / 2.0f, 0.0f);
                    float ratio = 1.0f + (1000.0f - flip_param.elapsed_ms) / ratio_base;
                    Gl.glScalef(ratio, ratio, 1.0f);
                    u.sprite.Draw();
                }
            }

            if(flip_param.elapsed_ms >= 1000)
            {
                state = 0;
            }
#endif

        }

        class Setting
        {
            bool showfps;
            bool fullscreen;
            bool use_opengl;
        }

        public int RatioToPixelH(double h)
        {
            return (int)(Width * h / 100.0);
        }
        public int RatioToPixelV(double v)
        {
            return (int)(Height * v / 100.0);
        }
        public int RatioToPixel(double l)
        {
            if (Width > Height)
            {
                return RatioToPixelV(l);
            }
            else
            {
                return RatioToPixelH(l);
            }
        }

        public int Width;
        public int Height;
    }

}
