﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using System.Drawing;
using System.IO;
using Tao.Lua;
using Tao.OpenGl;

namespace SPS2
{

    public class Page
    {
        /// <summary>
        /// ページのセッティング
        /// </summary>
        public class Setting
        {
            public Bg bg;
            SPS2.Flip_Driver flip_driver;
            public Color backcolor;
            public Color forecolor;
            public SPS2.HORIZONTAL_ALIGN halign;
            public int hmargin;

            public Setting()
            {
                bg = new Bg();
            }
        }

        public List<DrawUnit> drawunits;
        public int pauselevel_max;
        public string[] source;
        public string title;


        public Setting setting;

        public Page()
        {
            setting = new Setting();
            drawunits = new List<DrawUnit>();
        }
        // ディスプレイリスト

        public void Add(DrawUnit u)
        {
            drawunits.Add(u);

        }

        public void Parse(RenderContext context)
        {
            context.page_current = this;

            // TODO: dostringだとAccessVioliationExceptionが出てしまう

            //int status = Lua.luaL_dostring(context.lua, String.Join("\r\n", source));
            string path = "tmp.txt";
            File.WriteAllLines(path, source);
            int status = Lua.luaL_dofile(context.lua, path);
            if (status != 0)
            {
                SPS2.Instance.Log.Write(Log.Level.Error, "Lua::Error::" + Lua.lua_tostring(context.lua, 1));
                Lua.lua_pop(context.lua, 1);
            }
        }
        public void Draw(Display d, int pauselevel)
        {
            foreach (DrawUnit u in drawunits)
            {
                if (u.pauselevel > pauselevel) continue;

                u.Draw(d);
            }

        }
    }

    public class Scene
    {
        public Page page;
        public int pauselevel;

        public Scene() { }
        public Scene(Page page, int pauselevel)
        {
            this.page = page;
            this.pauselevel = pauselevel;
        }
        public Scene(Scene from) : this(from.page, from.pauselevel)
        {
        }
        public void Draw(Display d)
        {
            page.Draw(d, pauselevel);
        }
    }

}
