﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.IO;
namespace SPS2
{
    public class Presentation
    {
        public int pageno_max
        {
            get
            {
                return pages.Count - 1;
            }
        }
        List<Page> pages;
        public List<Page> Pages { get { return pages; } }
        public string title;

        public Presentation()
        {
            pages = new List<Page>();
            title = "Untitled";
        }
        private void Include(RenderContext context, ref List<string> source, string line)
        {
            bool in_quote = false;
            StringBuilder path = new StringBuilder();
            for (int i = 0; i < line.Length; i++)
            {
                if (line[i] == '"')
                {
                    if (in_quote)
                    {
                        ReadLines(context, ref source, File.ReadAllLines(path.ToString()));
                        return;
                    }
                    else
                    {
                        in_quote = true;
                    }
                }
                else
                {
                    if (in_quote)
                    {
                        path.Append(line[i]);
                    }
                }
            }
        }
        private void ReadLines(RenderContext context, ref List<string> source, string[] lines)
        {
            foreach (string line in lines)
            {
                if (line.StartsWith("sps_include("))
                {
                    Include(context, ref source, line);
                }
                else
                {
                    source.Add(line);
                    if (line == "sps_endpage()")
                    {
                        Page p = new Page();
                        p.source = source.ToArray();
                        pages.Add(p);

                        source = new List<string>();
                    }
                }
            }

        }
        public void ReadFile(RenderContext context, string filepath)
        {
            List<string> source = new List<string>();
            ReadLines(context, ref source, File.ReadAllLines(filepath));
        }
        public void ParseAll(RenderContext context)
        {
            context.pageno = 0;
            foreach (Page page in pages)
            {
                context.pageno++;
                page.Parse(context);
            }

        }
    }

}
